#include<stdio.h>
#include<math.h>	// Լ(exp,log)
#include<stdlib.h>	// exit(0)

int open(double data[][2]);		// Ͱ  TEXT  ҷ
void normal(double data[][2],int num,double *a,double *b);  // ȸͺм Թ
void linear(double data[][2],int num);		// ȸͺм
void polynomial(double data[][2],int num);	// ׽ ȸͺм
void matrix(double mat[20][20],double a[20],int n);	//   Ǯ(콺 ҰŹ)
void exponential(double data[][2],int num);	// 
void power(double data[][2],int num);		// 
void saturation(double data[][2],int num);	// ȭ 



void main()
{
	int num, choice;
	double data[50][2];
	
	printf("##########################################\n");
	printf("###  Least-Squares Regression Program  ###\n");
	printf("###     2007-2 MSE 20011089 Jihun Kim  ###\n");
	printf("##########################################\n\n");

input:	
	num=open(data)-1;	// TEXT  ҷ
	
	printf("\n");
	for(int i=0;i<num;i++)
		printf("%lf\t%lf\n",data[i][0],data[i][1]);

	printf("\n#1.Linear\t\n");
	printf("#2.Polynomial\n");
	printf("#3.Exponential\n");
	printf("#4.Power\n");
	printf("#5.Saturation-growth-rate\n");
	printf("#9.Open another data file\n");
	printf("#0.EXIT\n");
		
	while(1){

		printf("\n>>Select number: ");
		scanf("%d",&choice);
		
		if(choice==1)
			linear(data,num);
		else if(choice==2)
			polynomial(data,num);
		else if(choice==3)
			exponential(data,num);
		else if(choice==4)
			power(data,num);
		else if(choice==5)
			saturation(data,num);
		else if(choice==9)	// ؽƮ  ٲٱ
			goto input;
		else if(choice==0)	// 
			exit(0);
		else
			printf("ERROR! Select between 1~5\n");
	}
}


		
int open(double data[][2])	// Ͱ  TEXT  ҷ
{
	FILE *fp;
	char filename[50];

retry:
	printf(">>Input data file name: ");
	scanf("%s",&filename);
	
	fp=fopen(filename,"r");

	int temp,count=0;

	if(fp==NULL){
		printf("Path or File Not Found\n");	//  Ǵ ϸ ߸ Է½  Է
		goto retry;
	}

	do{
		temp=fscanf(fp,"%lf %lf",&data[count][0],&data[count][1]);
		count++;
	}while(temp!=EOF);
		
	fclose(fp); 

	return count;
}



void normal(double data[][2],int num,double *a,double *b)	// ȸͺм Թ
{
	double sum_x=0,sum_x2=0,sum_y=0,sum_xy=0;
		
	for(int i=0;i<num;i++)
	{
		sum_x=sum_x+data[i][0];
		sum_x2=sum_x2+data[i][0]*data[i][0];
		sum_y=sum_y+data[i][1];
		sum_xy=sum_xy+data[i][0]*data[i][1];
	}

	*b=(num*sum_xy-sum_x*sum_y)/(num*sum_x2-sum_x*sum_x);
	*a=sum_y/num-*b*sum_x/num;
}



void linear(double data[][2],int num)	// ȸͺм
{
	double a[2],Sr=0,Syx;

	normal(data,num,&a[0],&a[1]);
	
	for(int i=0;i<num;i++)		// ġ ǥؿ
		Sr=Sr+pow(data[i][1]-a[0]-a[1]*data[i][0],2);
	Syx=sqrt(Sr/(num-2));
	
	printf("Y=a0+a1*X\n",a[0],a[1]);
	printf("a0=%lf\na1=%lf\n",a[0],a[1]);
	printf("Sy/x=%.8lf\n",Syx);
}



void exponential(double data[][2],int num)	// 
{
	double temp[50][2],a[2],Sr=0,Syx;
	
	for(int i=0;i<num;i++)	// -->ȭ
	{
		temp[i][0]=data[i][0];
		temp[i][1]=log(data[i][1]);
	}
	
	normal(temp,num,&a[0],&a[1]);
	
	for(int i=0;i<num;i++)		// ġ ǥؿ
		Sr=Sr+pow(data[i][1]-exp(a[0])*exp(a[1]*data[i][0]),2);
	Syx=sqrt(Sr/(num-2));
	
	printf("Y=a*exp(b*X)\n");
	printf("a=%lf\nb=%lf\n",exp(a[0]),a[1]);
	printf("Sy/x=%.8lf\n",Syx);
}



void power(double data[][2],int num)	// 
{
	double temp[50][2],a[2],Sr=0,Syx;
	
	for(int i=0;i<num;i++)	// -->ȭ
	{
		temp[i][0]=log(data[i][0]);
		temp[i][1]=log(data[i][1]);
	}

	normal(temp,num,&a[0],&a[1]);

	for(int i=0;i<num;i++)		// ġ ǥؿ
		Sr=Sr+pow(data[i][1]-exp(a[0])*pow(data[i][0],a[1]),2);
	Syx=sqrt(Sr/(num-2));

	printf("Y=a*X^b)\n");
	printf("a=%lf\nb=%lf\n",exp(a[0]),a[1]);
	printf("Sy/x=%.8lf\n",Syx);
}



void saturation(double data[][2],int num)	// ȭ 
{
	double temp[50][2],a[2],Sr=0,Syx;
	
	for(int i=0;i<num;i++)	// -->ȭ
	{
		temp[i][0]=1/data[i][0];
		temp[i][1]=1/data[i][1];
	}

	normal(temp,num,&a[0],&a[1]);

	for(int i=0;i<num;i++)		// ġ ǥؿ
		Sr=Sr+pow(data[i][1]-1/a[0]*data[i][0]/(a[1]/a[0]+data[i][0]),2);
	Syx=sqrt(Sr/(num-2));

	printf("Y=a*X/(b+X)\n");
	printf("a=%lf\nb=%lf\n",1/a[0],a[1]/a[0]);
	printf("Sy/x=%.8lf\n",Syx);
}



void polynomial(double data[][2],int num)	// ׽(0 ̻) ȸͺм
{
	int order,i,j;
	double comp[20][20],sum_x[40]={0},sum_xy[20]={0};
	double a[20],y[20]={0};
	double Sr=0,Syx;
	
error:
		printf(">>Input order of polynomial:");
		scanf("%d",&order);
	
	if(num<=order)		//    ũ  ȸͺм Ҵ,  Է
	{
		printf("ERROR! order>=number of data\n");
		goto error;
	}
	else if(order<0)	//  ̸  Է
	{
		printf("ERROR! order>=0\n");
		goto error;
	}
	

	for(i=0;i<=order*2;i++)
	{
		for(j=0;j<num;j++)
		{
			sum_x[i]=sum_x[i]+pow(data[j][0],i);
		}
	}

	for(i=0;i<=order;i++)
	{
		for(j=0;j<num;j++)
		{
			sum_xy[i]=sum_xy[i]+pow(data[j][0],i)*data[j][1];
		}
	}

	for(i=0;i<=order;i++)
	{
		for(j=0;j<=order;j++)
		{
			comp[i][j]=sum_x[i+j];
		}
	}

	for(i=0;i<=order;i++)
	{
		comp[i][order+1]=sum_xy[i];
	}

	matrix(comp,a,order+1);		// ׽  ϱ(콺 ҰŹ)

	for(i=0;i<num;i++)		// ġ ǥؿ
	{
		for(j=0;j<=order;j++)
			y[i]=y[i]+a[j]*pow(data[i][0],j);
		Sr=Sr+pow(data[i][1]-y[i],2);
	}

	printf("Y=a0",a[0]);
	for(i=1;i<=order;i++)
		printf("+a%d*X^%d",i,i);
	printf("\n");
	
	for(i=0;i<=order;i++)
		printf("a%d=%lf\n",i,a[i]);
	
	Syx=sqrt(Sr/(num-2));
	printf("Sy/x=%.8lf\n",Syx);
}




void matrix(double mat[20][20],double a[20],int n)	//   Ǯ(콺 ҰŹ)
{
	//    Է
	int i,j,k,x,y;
	double max,temp,factor;

	// Normalization
	for(i=0;i<n;i++)
	{
		max=mat[i][0];
		
		for(j=1;j<=n;j++)
			if(max<abs(mat[i][j]))
				max=mat[i][j];
						
		for(j=0;j<=n;j++)
			mat[i][j]=mat[i][j]/max;
	}

	// Partial Pivoting
	for(j=0;j<n-1;j++)
	{
		// ش   ū  (aii 0 Ȯ)
		for(i=n-1;i>j;i--)
		{
			if(abs(mat[i][j])>abs(mat[i-1][j]))
			{
				for(k=0;k<=n;k++)
				{
					temp=mat[i][k];
					mat[i][k]=mat[i-1][k];
					mat[i-1][k]=temp;
				}
			}
		}
		
		// :  Ұ
		for(i=j;i<n-1;i++)
		{
			if(mat[i+1][j]==0) continue;

			factor=mat[j][j]/mat[i+1][j];

			for(k=0;k<=n;k++)
				mat[i+1][k]=mat[j][k]-mat[i+1][k]*factor;
		}
	}

	// Gauss-Jordan Elimination
	for(j=n-1;j>0;j--)
	{
		for(i=j;i>0;i--)
		{
			if(mat[i-1][j]==0) continue;

			factor=mat[j][j]/mat[i-1][j];

			for(k=0;k<=n;k++)
				mat[i-1][k]=mat[j][k]-mat[i-1][k]*factor;
		}
	}

	// 
	for(j=0;j<n;j++)
		a[j]=mat[j][n]/mat[j][j];
}